/*
 * PM - 2016
 * lab0.c
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		100
#define NUM_SECVENTE		6

#define MORSE_LUNG		3

#define NUM_NOTE		8
#define DURATA_NOTA		100
#define MORSE_SCURT		1

volatile int octave = 4; //octava initiala

float frecventa_nota[8][8] = {
	{16.35, 18.35, 20.60, 21.83, 24.50, 27.50, 30.87, 32.70},
	{32.70, 36.71, 41.20, 43.65, 49.00, 55.00, 61.74, 65.41},
	{65.41, 73.42, 82.41, 87.31, 98.00, 110.00, 123.47, 130.81},
	{130.81, 146.83, 164.81,174.61, 196.00, 220.00, 246.94, 261.63},
	{261.63, 293.66, 329.66, 349.23, 392.00, 440.00, 493.88, 523.25},
	{523.25, 587.33, 659.25, 698.54, 783.99, 880.00, 987.77, 1046.50},
	{1046.50, 1174.66, 1318.51, 1396.91, 1567.98, 1760.00, 1975.53, 2093.00},
	{2096.00, 2349.32, 2637.02, 2793.83, 3135.96, 3520.00, 3951.07, 4186.01}
};

/* initializeaza ADC fara intreruperi */
void init_ADC(void) {
	ADMUX = ( 1 << REFS0);
	ADCSRA = (1 << ADEN) | (7 << ADPS0);
}

/* ia valoarea de la ADC */
int get_ADC(uint8_t channel) {	
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

	ADCSRA |= (1 << ADSC);
	while(!bit_is_set(ADCSRA,ADIF));
	return ADC;
}

/* display 7-segment */
void show() {
	PORTC = 0x00;
	if (octave == 0) {
		PORTC |= (1 << PC5);
		PORTC |= (1 << PC6);
	}
	if (octave + 1 == 2) {
		PORTC |= (1 << PC4);
		PORTC |= (1 << PC5);
		PORTC |= (1 << PC0);
		PORTC |= (1 << PC2);
		PORTC |= (1 << PC3);
	}
	if (octave + 1 == 3) {
		PORTC |= (1 << PC4);
		PORTC |= (1 << PC5);
		PORTC |= (1 << PC0);
		PORTC |= (1 << PC6);
		PORTC |= (1 << PC3);
	}
	if (octave + 1 == 4) {
		PORTC |= (1 << PC1);
		PORTC |= (1 << PC0);
		PORTC |= (1 << PC5);
		PORTC |= (1 << PC6);
	}
	if (octave + 1 == 5) {
		PORTC |= (1 << PC4);
		PORTC |= (1 << PC1);
		PORTC |= (1 << PC0);
		PORTC |= (1 << PC6);
		PORTC |= (1 << PC3);
	}
	if (octave + 1 == 6) {
		PORTC |= (1 << PC4);
		PORTC |= (1 << PC1);
		PORTC |= (1 << PC2);
		PORTC |= (1 << PC3);
		PORTC |= (1 << PC6);
		PORTC |= (1 << PC0);
	}
	if (octave + 1 == 7) {
		PORTC |= (1 << PC4);
		PORTC |= (1 << PC5);
		PORTC |= (1 << PC6);
	}
	if (octave + 1 == 8) {
		PORTC |=(1 << PC0);
		PORTC |=(1 << PC1);
		PORTC |=(1 << PC2);
		PORTC |=(1 << PC3);
		PORTC |=(1 << PC4);
		PORTC |=(1 << PC5);
		PORTC |=(1 << PC6);
	}
}

void buzzer_reda(int nota) {
	float perioada_nota = 100000 / frecventa_nota[octave][nota];
	int i, j;
	int x;

	/* durata mai scurta pentru notele foarte joase */
	if (perioada_nota > 1000)
		x = 10;
	else
		x = DURATA_NOTA;
		for (i = 0; i < x; i++) {
			PORTD |= (1 << PD5);

			for (j = 0; j < perioada_nota / 2; ++j)
				_delay_us(1);

			PORTD &= ~(1 << PD5);

			for (j = 0 ; j < perioada_nota / 2; ++j)
				_delay_us(1);
			
		}
}


/* Aprinde led-ul PA0 la apasarea butonului PB0. */
void exemplu(void) {
	MCUCR |= (1 << JTD);
	MCUCR |= (1 << JTD);
	int ok = 0;

	init_ADC();
	show();

	DDRB = 0x00;
	PORTB = 0x00;
	DDRB &= ~(1 << PB2);
	DDRB &= ~(1 << PB3);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);

	DDRC = 0xFF;
	PORTC = 0x00;

	DDRD |= (1 << PD5);
	PORTD &= ~(1 << PD5);

	_delay_us(1000);

	while (1) {
		/* Daca butonul PB2 este apasat. */
		if (((PINB & (1 << PB2)) == 0) && (ok == 0)) {
			ok = 1;
			octave = (octave + 1);
			if (octave == 8)
				octave = 0;
			show();
		}

		/* Daca butonul PB3 este apasat. */
		if (((PINB & (1 << PB3)) == 0) && (ok == 0)) {
			ok = 1;
			octave = (octave - 1);
			if (octave == -1)
				octave = 7;
			show();
		}

		if (((PINB & (1 << PB2)) != 0) && ((PINB & (1 << PB3)) != 0)) {
			ok = 0;
		}

		/* Daca s-a intrerupt un laser, canta nota respectiva */
		int i;
		for (i = 1; i < 8; i++) {
			int val = get_ADC(i);
			if (val > 400)
				buzzer_reda(i);
		}
	}
}
int main(void) {
	exemplu();

	return 0;
}
